<%-- $Id: list_categories.jsp 4476 2008-09-05 15:14:42Z jari $
	------------------------------------------------------------------
	Copyright (C) 2006 Nicklas Nordborg, Dominic Oyeniran
	Copyright (C) 2007 Johan Enell, Martin Svensson

	This file is part of BASE - BioArray Software Environment.
	Available at http://base.thep.lu.se/

	BASE is free software; you can redistribute it and/or
	modify it under the terms of the GNU General Public License
	as published by the Free Software Foundation; either version 3
	of the License, or (at your option) any later version.

	BASE is distributed in the hope that it will be useful,
	but WITHOUT ANY WARRANTY; without even the implied warranty of
	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
	GNU General Public License for more details.

	You should have received a copy of the GNU General Public License
	along with this program; if not, write to the Free Software
	Foundation, Inc., 59 Temple Place - Suite 330,
	Boston, MA  02111-1307, USA.
	------------------------------------------------------------------

	@author Dominic
	@version 2.0
--%>
<%@ page session="false"
	import="net.sf.basedb.core.SessionControl"
	import="net.sf.basedb.core.DbControl"
	import="net.sf.basedb.core.Item"
	import="net.sf.basedb.core.AnnotationTypeCategory"
	import="net.sf.basedb.core.AnnotationType"
	import="net.sf.basedb.core.ItemQuery"
	import="net.sf.basedb.core.Include"
	import="net.sf.basedb.core.Type"
	import="net.sf.basedb.core.Metadata"
	import="net.sf.basedb.core.ItemResultIterator"
	import="net.sf.basedb.core.ItemResultList"
	import="net.sf.basedb.core.ItemContext"
	import="net.sf.basedb.core.Nameable"
	import="net.sf.basedb.core.Permission"
	import="net.sf.basedb.core.PluginDefinition"
	import="net.sf.basedb.core.query.Restrictions"
	import="net.sf.basedb.core.query.Expressions"
	import="net.sf.basedb.core.query.Orders"
	import="net.sf.basedb.core.query.Hql"
	import="net.sf.basedb.core.plugin.GuiContext"
	import="net.sf.basedb.core.plugin.Plugin"
	import="net.sf.basedb.util.Enumeration"
	import="net.sf.basedb.util.ShareableUtil"
	import="net.sf.basedb.clients.web.Base"
	import="net.sf.basedb.clients.web.ModeInfo"
	import="net.sf.basedb.clients.web.util.HTML"
	import="net.sf.basedb.util.Values"
	import="net.sf.basedb.clients.web.PermissionUtil"
	import="java.util.Iterator"
	import="java.util.List"
	import="java.util.Map"
	import="java.util.Set"
%>
<%@ taglib prefix="base" uri="/WEB-INF/base.tld" %>
<%@ taglib prefix="tbl" uri="/WEB-INF/table.tld" %>
<%@ taglib prefix="m" uri="/WEB-INF/menu.tld" %>
<%!
	private static final Item itemType = Item.ANNOTATIONTYPECATEGORY;
	private static final GuiContext guiContext = new GuiContext(itemType, GuiContext.Type.LIST);
		
%>
<%
final SessionControl sc = Base.getExistingSessionControl(pageContext, Permission.DENIED, itemType);
final String ID = sc.getId();
final boolean createPermission = sc.hasPermission(Permission.CREATE, itemType);
final ItemContext cc = Base.getAndSetCurrentContext(sc, itemType, null, null);

final ModeInfo mode = ModeInfo.get(request.getParameter("mode"));
final String callback = request.getParameter("callback");
final String title = mode.generateTitle("annotation type category", "annotation type categories");
final DbControl dc = sc.newDbControl();
ItemResultIterator<AnnotationTypeCategory> annotationTypeCategories = null;
try
{

	// Query for annotation types in the current category
	final ItemQuery<AnnotationType> annotationTypeQuery = AnnotationType.getQuery(null);
	annotationTypeQuery.include(cc.getInclude());
	annotationTypeQuery.join(Hql.innerJoin("categories", "ctg"));
	annotationTypeQuery.restrict(Restrictions.eq(Hql.alias("ctg"), Expressions.parameter("category")));
	annotationTypeQuery.order(Orders.asc(Hql.property("name"))); 

	Map<Plugin.MainType, Integer> pluginCount = PluginDefinition.countPlugins(dc, guiContext);
	try
	{
		final ItemQuery<AnnotationTypeCategory> query = 
			Base.getConfiguredQuery(cc, true, AnnotationTypeCategory.getQuery(), mode);
		annotationTypeCategories = query.iterate(dc);
	}
	catch (Throwable ex)
	{
		cc.setMessage(ex.getMessage());
	}
	int numListed = 0;
	%>
	<base:page title="<%=title==null ? "Annotation type categories" : title%>" type="<%=mode.getPageType()%>">
	
	<base:head scripts="menu.js,table.js" styles="menu.css,table.css">
		<script language="JavaScript">
		var submitPage = 'index.jsp';
		var formId = 'annotationTypeCategories';
		function newItem()
		{
			Main.viewOrEditItem('<%=ID%>', '<%=itemType.name()%>', 0, true);
		}
		function editItem(itemId)
		{
			Main.viewOrEditItem('<%=ID%>', '<%=itemType.name()%>', itemId, true);
		}
		function viewItem(itemId)
		{
			Main.viewOrEditItem('<%=ID%>', '<%=itemType.name()%>', itemId, false);
		}
		function itemOnClick(evt, itemId)
		{
			Table.itemOnClick(formId, evt, itemId, '<%=mode.getName()%>', viewItem, editItem, returnSelected);
		}
		function deleteItems()
		{
			var frm = document.forms[formId];
			if (Forms.numChecked(frm) == 0)
			{
				alert('Please select at least on item in the list');
				return; 
			}
			frm.action = submitPage;
			frm.cmd.value = 'DeleteItems';
			frm.submit();
		}
		function restoreItems()
		{
			var frm = document.forms[formId];
			if (Forms.numChecked(frm) == 0)
			{
				alert('Please select at least on item in the list');
				return; 
			}
			frm.action = submitPage;
			frm.cmd.value = 'RestoreItems';
			frm.submit();
		}
		function deleteItemPermanently(itemId)
		{
			Main.deleteItemPermanently('<%=ID%>', true, '<%=itemType.name()%>', itemId);
		}
		function takeOwnership()
		{
			var frm = document.forms[formId];
			if (Forms.numChecked(frm) == 0)
			{
				alert('Please select at least one item in the list');
				return; 
			}
			if (confirm('Are you sure that you want to take ownership of the selected items? It can\'t be undone.'))
			{
				frm.action = submitPage;
				frm.cmd.value = 'TakeOwnershipOfItems';
				frm.submit();
			}
		}
		function shareItem(itemId)
		{
			Main.openPopup('index.jsp?ID=<%=ID%>&cmd=ShareItem&item_id='+itemId, 'ShareAnnotationTypeCategories', 600, 400);
		}
		function shareItems()
		{
			Table.shareItems(submitPage, '<%=ID%>', formId, '<%=itemType.name()%>', 'ShareItems');
		}
		function configureColumns()
		{
			Table.configureColumns('<%=ID%>', formId, '<%=itemType.name()%>', '<%=(String)cc.getObject("defaultColumns")%>');
		}
		function runPlugin(cmd)
		{
			Table.submitToPopup(formId, cmd, 740, 540);
		}
		function returnSelected()
		{
			Table.returnSelected(formId, <%=callback != null ? "window.opener."+callback : "null" %>);
			window.close();
		}
		function presetOnChange()
		{
			Table.presetOnChange('<%=ID%>', formId, '<%=itemType.name()%>', '<%=(String)cc.getObject("defaultColumns")%>');
		}
		</script>
	</base:head>
	
	<base:body>
		<%
		if (cc.getMessage() != null)
		{
			%>
			<div class="error"><%=cc.getMessage()%></div>
			<%
			cc.setMessage(null);
		}
		%>
		<tbl:table 
			id="annotationTypeCategories" 
			clazz="itemlist" 
			columns="<%=cc.getSetting("columns")%>"
			sortby="<%=cc.getSortProperty()%>" 
			direction="<%=cc.getSortDirection()%>"
			title="<%=title%>"
			action="index.jsp"
			sc="<%=sc%>"
			item="<%=itemType%>"
			>
			<tbl:hidden 
				name="mode" 
				value="<%=mode.getName()%>" 
			/>
			<tbl:hidden 
				name="callback" 
				value="<%=callback%>" 
				skip="<%=callback == null%>" 
			/>

			<tbl:columndef 
				id="name"
				property="name"
				datatype="string"
				title="Name"
				sortable="true" 
				filterable="true"
				exportable="true"
				show="always" 
			/>
			<tbl:columndef 
				id="id"
				clazz="uniquecol"
				property="id"
				datatype="int"
				title="ID"
				sortable="true"
				filterable="true"
				exportable="true"
			/>
			<tbl:columndef 
				id="annotationTypes"
				title="Annotation types"
			/>
			<tbl:columndef 
				id="owner"
				property="owner.name"
				datatype="string"
				title="Owner"
				sortable="true" 
				filterable="true"
				exportable="true"
			/>
			<tbl:columndef 
				id="description"
				property="description"
				datatype="string"
				title="Description" 
				sortable="true" 
				filterable="true" 
				exportable="true"
			/>
			<tbl:columndef
				id="permission"
				title="Permission"
			/>
			<tbl:columndef
				id="sharedTo"
				title="Shared to"
			/>
			<tbl:toolbar
				visible="<%=mode.hasToolbar()%>"
				>
				<tbl:button 
					disabled="<%=createPermission ? false : true%>" 
					image="<%=createPermission ? "new.gif" : "new_disabled.gif"%>" 
					onclick="newItem()" 
					title="New&hellip;" 
					tooltip="<%=createPermission ? "Create new annotation type category" : "You do not have permission to create annotation type categories"%>" 
				/>
				<tbl:button 
					image="delete.gif"
					onclick="deleteItems()" 
					title="Delete" 
					tooltip="Delete the selected items" 
				/>
				<tbl:button 
					image="restore.gif"
					onclick="restoreItems()" 
					title="Restore" 
					tooltip="Restore the selected (deleted) items"
				/>
				<tbl:button 
					image="share.gif"
					onclick="shareItems()" 
					title="Share&hellip;" 
					tooltip="Share the selected items"
				/>
				<tbl:button 
					image="take_ownership.png"
					onclick="takeOwnership()" 
					title="Take ownership&hellip;"
					tooltip="Take ownership of the selected items"
				/>
				<tbl:button 
					image="columns.gif" 
					onclick="configureColumns()" 
					title="Columns&hellip;" 
					tooltip="Show, hide and re-order columns" 
				/>
				<tbl:button 
					image="import.gif" 
					onclick="runPlugin('ImportItems')" 
					title="Import&hellip;" 
					tooltip="Import data" 
					visible="<%=pluginCount.containsKey(Plugin.MainType.IMPORT)%>"
				/>
				<tbl:button 
					image="export.gif" 
					onclick="runPlugin('ExportItems')" 
					title="Export&hellip;" 
					tooltip="Export data" 
					visible="<%=pluginCount.containsKey(Plugin.MainType.EXPORT)%>"
				/>
				<tbl:button 
					image="runplugin.gif" 
					onclick="runPlugin('RunListPlugin')" 
					title="Run plugin&hellip;" 
					tooltip="Run a plugin" 
					visible="<%=pluginCount.containsKey(Plugin.MainType.OTHER)%>"
				/>
			</tbl:toolbar>
			<tbl:navigator
				page="<%=cc.getPage()%>" 
				rowsperpage="<%=cc.getRowsPerPage()%>" 
				totalrows="<%=annotationTypeCategories == null ? 0 : annotationTypeCategories.getTotalCount()%>" 
				visible="<%=mode.hasNavigator()%>"
			/>
			<tbl:data>
				<tbl:columns>
				<tbl:presetselector 
					clazz="columnheader"
					colspan="3"
					onchange="presetOnChange()"
				/>
				</tbl:columns>

				<tr>
					<tbl:header 
						clazz="index"
						>&nbsp;</tbl:header>
					<tbl:header 
						clazz="check" 
						visible="<%=mode.hasCheck()%>"
						><base:icon 
							image="check_uncheck.gif" 
							tooltip="Check/uncheck all" 
							onclick="Forms.checkUncheck(document.forms[formId])" style="align: left;"
						/></tbl:header>
					<tbl:header 
						clazz="check" 
						visible="<%=mode.hasRadio()%>"
						>&nbsp;</tbl:header>
					<tbl:header 
						clazz="icons" 
						visible="<%=mode.hasIcons()%>"
						>&nbsp;</tbl:header>
					<tbl:propertyfilter />
				</tr>
					
					<tbl:rows>
					<%
					int index = cc.getPage()*cc.getRowsPerPage();
					int selectedItemId = cc.getId();
					if (annotationTypeCategories != null)
					{
						while (annotationTypeCategories.hasNext())
						{
							AnnotationTypeCategory item = annotationTypeCategories.next();
							int itemId = item.getId();
							String openSharePopup = "shareItem("+itemId+")";
							String name = HTML.encodeTags(item.getName());
							String deletePermanently = "deleteItemPermanently("+itemId+")";
							boolean deletePermission = item.hasPermission(Permission.DELETE);
							boolean sharePermission = item.hasPermission(Permission.SET_PERMISSION);
							boolean writePermission = item.hasPermission(Permission.WRITE);
							String tooltip = mode.isSelectionMode() ? 
									"Select this item" : "View this item" + (writePermission ? " (use CTRL, ALT or SHIFT to edit)" : "");
							index++;
							numListed++;
							%>
							<tbl:row>
								<tbl:header 
									clazz="index"
									><%=index%></tbl:header>
								<tbl:header 
									clazz="check" 
									visible="<%=mode.hasCheck()%>"
									><input 
										type="checkbox" 
										name="<%=itemId%>" 
										value="<%=itemId%>" 
										title="<%=name%>" 
										<%=cc.getSelected().contains(itemId) ? "checked" : ""%> 
									></tbl:header>
								<tbl:header 
									clazz="check" 
									visible="<%=mode.hasRadio()%>"
									><input 
										type="radio" 
										name="item_id" 
										value="<%=itemId%>" 
										title="<%=name%>" 
										<%=selectedItemId == itemId ? "checked" : ""%>
									></tbl:header>
								<tbl:header 
									clazz="icons" 
									visible="<%=mode.hasIcons()%>"
									><base:icon 
										image="<%=deletePermission ? "deleted.gif" : "deleted_disabled.gif"%>"
										onclick="<%=deletePermission ? deletePermanently : null%>"
										tooltip="This item has been scheduled for deletion" 
										visible="<%=item.isRemoved()%>"
									/><base:icon 
										image="<%=sharePermission ? "shared.gif" : "shared_disabled.gif"%>" 
										onclick="<%=sharePermission ? openSharePopup : null%>"
										tooltip="This item is shared to other users, groups and/or projects" 
										visible="<%=item.isShared()%>"
									/>&nbsp;</tbl:header>
								<tbl:cell column="name"><div class="link" 
									onclick="itemOnClick(<%=writePermission ? "event" : null%>, <%=itemId%>)" 
									title="<%=tooltip%>"><%=name%></div></tbl:cell>
								<tbl:cell column="id"><%=item.getId()%></tbl:cell>
								<tbl:cell column="owner"><base:propertyvalue item="<%=item%>" property="owner.name" /></tbl:cell>
								<tbl:cell column="description"><%=HTML.encodeTags(item.getDescription())%></tbl:cell>
								<tbl:cell column="permission"><%=PermissionUtil.getShortPermissions(item)%></tbl:cell>
								<tbl:cell column="annotationTypes">
									<%
									annotationTypeQuery.setParameter("category", itemId, Type.INT);
									try
									{
										String separator = "";
										for (AnnotationType at : annotationTypeQuery.list(dc))
										{
											out.write(separator);
											if (mode.hasPropertyLink())
											{
												out.write(Base.getLinkedName(ID, at, false, mode.hasEditLink()));
											}
											else
											{
												out.write(HTML.encodeTags(at.getName()));
											}
											separator = ", ";
										}
									}
									catch (Throwable t)
									{
										%>
										<div class="error"><%=t.getMessage()%></div>
										<%
									}
									%>
								</tbl:cell>
								<tbl:cell column="sharedTo">
									<%
									Iterator<Nameable> sharees = ShareableUtil.getSharedTo(dc, item).iterator();
									while(sharees.hasNext())
									{
										Nameable n = sharees.next();
										if (mode.hasPropertyLink())
										{
											out.write(Base.getLinkedName(ID, n, false, mode.hasEditLink()));
										}
										else
										{
											out.write(HTML.encodeTags(n.getName()));
										}
										out.write(sharees.hasNext() ? ", " : "");
									}
									%>
								</tbl:cell>
							</tbl:row>
							<%
						}
					}
					%>
					</tbl:rows>
			</tbl:data>
			<%
			if (numListed == 0)
			{
				%>
				<tbl:panel><%=annotationTypeCategories == null || annotationTypeCategories.getTotalCount() == 0 ? "No annotation type categories were found" : "No annotation types categories on this page. Please select another page!" %></tbl:panel>
				<%
			}
			else
			{
				%>
				<tbl:navigator
					page="<%=cc.getPage()%>" 
					rowsperpage="<%=cc.getRowsPerPage()%>" 
					totalrows="<%=annotationTypeCategories == null ? 0 : annotationTypeCategories.getTotalCount()%>" 
					visible="<%=mode.hasNavigator()%>"
					locked="true"
				/>
				<%
			}
			%>
		</tbl:table>
		<base:buttongroup align="center" clazz="fixedatbottom">
			<base:button onclick="returnSelected();" title="Ok" visible="<%=mode.hasOkButton()%>" />
			<base:button onclick="window.close();" title="Cancel" visible="<%=mode.hasCancelButton()%>" />
			<base:button onclick="window.close();" title="Close" visible="<%=mode.hasCloseButton()%>" />
		</base:buttongroup>
		<br><br><br>
	</base:body>
	</base:page>
	<%
}
finally
{
	if (annotationTypeCategories != null) annotationTypeCategories.close();
	if (dc != null) dc.close();
}
%>
