<%-- $Id: close_popup.jsp 4476 2008-09-05 15:14:42Z jari $
	------------------------------------------------------------------
	Copyright (C) 2005 Nicklas Nordborg
	Copyright (C) 2006 Jari Hakkinen, Nicklas Nordborg

	This file is part of BASE - BioArray Software Environment.
	Available at http://base.thep.lu.se/

	BASE is free software; you can redistribute it and/or
	modify it under the terms of the GNU General Public License
	as published by the Free Software Foundation; either version 3
	of the License, or (at your option) any later version.

	BASE is distributed in the hope that it will be useful,
	but WITHOUT ANY WARRANTY; without even the implied warranty of
	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
	GNU General Public License for more details.

	You should have received a copy of the GNU General Public License
	along with this program; if not, write to the Free Software
	Foundation, Inc., 59 Temple Place - Suite 330,
	Boston, MA  02111-1307, USA.
	------------------------------------------------------------------

	Closes a popup window.

	@param message
		A message to display before the popup is closed. If not
		specified the value "Settings saved" are used.

	@param title
		The title of the page.

	@param wait
		Milliseconds to wait before the popup is closed. If not
		specified 1200 is used.

	@param callback
		The name of a callback method that will be called on the
		opening window before the popup is closed.

	@param redirect_opener
		If specified the window that opened the popup will be redirected
		to this URL. Ignored if callback is specified.

	@param redirect_main
		If specified the main window will be redirected to this URL.
		Ignored if redirect_opener or callback is specified.

	@param refresh_opener
		If specified with a non-zero value the window that opened
		the popup will be reloaded. Ignored if redirect_main,
		redirect_opener or callback is specified.

	@author Nicklas
	@version 2.0
--%>
<%@ page session="false"
	import="net.sf.basedb.util.Values"
%>
<%@ taglib prefix="base" uri="/WEB-INF/base.tld" %>
<%
String message = Values.getString(request.getParameter("message"),"");
String title = Values.getString(request.getParameter("title"), message);
int millisecondsToWait = Values.getInt(request.getParameter("wait"), 1200);
String redirectOpener = request.getParameter("redirect_opener");
String redirectMain = request.getParameter("redirect_main");
String refreshOpener = request.getParameter("refresh_opener");
String reopenOpener = request.getParameter("reopen_opener");
String callback = request.getParameter("callback");

%>
<base:page type="popup" title="<%=title%>">
<base:head>
	<script language="JavaScript">
	function setClose(wait)
	{
		if (wait == 0)
		{
			closeIt();
		}
		else
		{
			setTimeout('closeIt()', wait);
		}
	}
	
	function closeIt()
	{
		this.focus();
		var topWindow = window.top;
		<%
		if (callback != null)
		{
			%>
			myOpener = topWindow.opener;
			if (myOpener.<%=callback%>) myOpener.<%=callback%>();
			<%
		}
		else if (redirectOpener != null)
		{
			%>
			myOpener = topWindow.opener;
			myOpener.location.href = '<%=redirectOpener%>';
			<%
		}
		else if (redirectMain != null)
		{
			%>
			main = topWindow.opener.top;
			main.location = '<%=redirectMain%>';
			<%
		}
		else if (refreshOpener != null && !refreshOpener.equals("0"))
		{
			%>
			myOpener = topWindow.opener;
			myOpener.location.reload();
			<%
		}
		%>
		topWindow.close();
	}
	</script>
</base:head>
<base:body onload="<%="setClose("+millisecondsToWait+")"%>" attributes="onclick='closeIt()';" >
		<base:note type="info" title="<%=title%>">
		<%=message%>
		</base:note>
</base:body>
</base:page>
