<%-- $Id: edit_file.jsp 4476 2008-09-05 15:14:42Z jari $
	------------------------------------------------------------------
	Copyright (C) 2006 Jari Hakkinen, Nicklas Nordborg, Martin Svensson
	Copyright (C) 2007 Nicklas Nordborg

	This file is part of BASE - BioArray Software Environment.
	Available at http://base.thep.lu.se/

	BASE is free software; you can redistribute it and/or
	modify it under the terms of the GNU General Public License
	as published by the Free Software Foundation; either version 3
	of the License, or (at your option) any later version.

	BASE is distributed in the hope that it will be useful,
	but WITHOUT ANY WARRANTY; without even the implied warranty of
	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
	GNU General Public License for more details.

	You should have received a copy of the GNU General Public License
	along with this program; if not, write to the Free Software
	Foundation, Inc., 59 Temple Place - Suite 330,
	Boston, MA  02111-1307, USA.
	------------------------------------------------------------------


	@author Nicklas
	@version 2.0
--%>
<%@ page session="false"
	import="net.sf.basedb.core.SessionControl"
	import="net.sf.basedb.core.DbControl"
	import="net.sf.basedb.core.Item"
	import="net.sf.basedb.core.SystemItems"
	import="net.sf.basedb.core.ItemContext"
	import="net.sf.basedb.core.Permission"
	import="net.sf.basedb.core.Directory"
	import="net.sf.basedb.core.File"
	import="net.sf.basedb.core.FileType"
	import="net.sf.basedb.core.ItemQuery"
	import="net.sf.basedb.core.ItemResultList"
	import="net.sf.basedb.core.PermissionDeniedException"
	import="net.sf.basedb.core.BaseException"
	import="net.sf.basedb.core.query.Orders"
	import="net.sf.basedb.core.query.Hql"
	import="net.sf.basedb.clients.web.Base"
	import="net.sf.basedb.clients.web.util.HTML"
	import="net.sf.basedb.util.Values"
	import="java.util.List"
	import="java.util.Set"
	import="java.util.HashSet"
%>
<%@ taglib prefix="base" uri="/WEB-INF/base.tld" %>
<%@ taglib prefix="t" uri="/WEB-INF/tab.tld" %>
<%
final Item itemType = Item.FILE;
final SessionControl sc = Base.getExistingSessionControl(pageContext, true);
final ItemContext cc = Base.getAndSetCurrentContext(sc, itemType, null, null);
final int itemId = cc.getId();
final String ID = sc.getId();
final float scale = Base.getScale(sc);
final DbControl dc = sc.newDbControl();
try
{
	String title = null;
	File file = null;
	Directory directory = null;
	boolean readCurrentFileType = true;
	int currentFileTypeId = 0;

	if (itemId == 0)
	{
		title = "Create file";
		currentFileTypeId = Values.getInt(cc.getPropertyValue("fileType"), 0);
		if (currentFileTypeId == 0)
		{
			currentFileTypeId = Values.getInt(cc.getRecent(Item.FILETYPE.name(), 0), 0);
		}
		directory = Directory.getById(dc, Values.getInt(request.getParameter("directory_id"), 
			SystemItems.getId(Directory.ROOT)));
		cc.removeObject("item");
	}
	else
	{
		file = File.getById(dc, itemId);
		directory = file.getDirectory();
		cc.setObject("item", file);
		title = "Edit file -- " + HTML.encodeTags(file.getName());
		try
		{
			FileType ft = file.getFileType();
			if (ft != null) currentFileTypeId = ft.getId();
		}
		catch (PermissionDeniedException ex)
		{
			readCurrentFileType = false;
		}
	}
	if (file != null && !file.hasPermission(Permission.WRITE))
	{
		throw new PermissionDeniedException(Permission.WRITE, itemType.toString());
	}
	
	// Query to retrieve file types
	final ItemQuery<FileType> fileTypeQuery = FileType.getQuery();
	fileTypeQuery.order(Orders.asc(Hql.property("name")));
	fileTypeQuery.setCacheResult(true);
	
	final String clazz = "class=\"text\"";
	final String requiredClazz = "class=\"text required\"";
	%>

	<base:page type="popup" title="<%=title%>">
	<base:head scripts="tabcontrol.js" styles="tabcontrol.css">
		<script language="JavaScript">
		// Validate the "File" tab
		function validateFile()
		{
			var frm = document.forms['file'];
			if (Main.trimString(frm.name.value) == '')
			{
				alert("You must enter a name");
				frm.name.focus();
				return false;
			}
			return true;
		}

		// Submit the form
		function saveSettings()
		{
			var frm = document.forms['file'];
			if (TabControl.validateActiveTab('settings'))
			{
				frm.submit();
			}
		}
		
		function init()
		{
			<%
			if (file == null)
			{
				%>
				var frm = document.forms['file'];
				frm.name.focus();
				frm.name.select();
				<%
			}
			%>
		}
		</script>
	</base:head>
	<base:body onload="init()">
		<p>
		<form action="index.jsp?ID=<%=ID%>" method="post" name="file" onsubmit="return false;">
		<input type="hidden" name="cmd" value="UpdateItem">
		<input type="hidden" name="directory_id" value="<%=directory.getId()%>">

		<h3 class="docked"><%=title%> <base:help tabcontrol="settings" /></h3>
		<t:tabcontrol id="settings" contentstyle="<%="height: "+(int)(scale*240)+"px;"%>" 
			position="bottom" remember="<%=file != null%>">
		<t:tab id="info" title="File" validate="validateFile()" helpid="file.edit">
			<table class="form" cellspacing=0>
			<tr>
				<td class="prompt">Path</td>
				<td><%=HTML.encodeTags(directory.getPath().toString())%></td>
			</tr>
			<tr>
				<td class="prompt">Name</td>
				<td><input <%=requiredClazz%> type="text" name="name" 
					value="<%=HTML.encodeTags(file == null ? Values.getString(cc.getPropertyValue("name"), "New file") : file.getName())%>" 
					size="40" maxlength="<%=File.MAX_NAME_LENGTH%>"></td>
			</tr>
			<tr>
				<td class="prompt">Write protected</td>
				<td><input type="checkbox" name="write_protected" value="1" 
					<%=(file != null && file.isWriteProtected()) || 
						(file == null && Values.getBoolean(cc.getPropertyValue("writeProtected"))) ? "checked" : ""%>></td>
			</tr>
			<tr valign="top">
				<td class="prompt">Type</td>
				<td colspan="2">
					<select name="filetype_id" <%=!readCurrentFileType ? "disabled readonly class=\"disabled\"" : ""%>>
					<%
					if (!readCurrentFileType)
					{
						%>
						<option value="-1">- denied -
						<%
					}
					else
					{
						%>
						<option value="0">- none -
						<%
						ItemResultList<FileType> fileTypes = fileTypeQuery.list(dc);
						for (FileType fileType : fileTypes)
						{
							int id = fileType.getId();
							%>
							<option 
								value="<%=file != null && id == currentFileTypeId ? -id : id%>" 
								<%=id == currentFileTypeId ? "selected" : ""%>
								><%=HTML.encodeTags(fileType.getName())%>
							<%
						}
					}
					%>
					</select>
				</td>
			</tr>
			<tr>
				<td class="prompt">MIME type</td>
				<td><input <%=clazz%> type="text" name="mime_type" 
					value="<%=HTML.encodeTags(file == null ? Values.getString(cc.getPropertyValue("mimeType")) : file.getMimeType())%>" 
					size="40" maxlength="<%=File.MAX_MIMETYPE_LENGTH%>"></td>
			</tr>

			<tr valign=top>
				<td class="prompt">Description</td>
				<td nowrap>
					<textarea <%=clazz%> rows="4" cols="40" name="description" wrap="virtual"
						><%=HTML.encodeTags(file == null ? cc.getPropertyValue("description") : file.getDescription())%></textarea>
					<a href="javascript:Main.zoom('Description', 'file', 'description')"
						title="Edit in larger window"><base:icon image="zoom.gif" /></a>
				</td>
			</tr>
			</table>
			<div align=right>&nbsp;<i><base:icon image="required.gif" /> = required information</i></div>
		</t:tab>

		</t:tabcontrol>

		<table align="center">
		<tr>
			<td width="50%"><base:button onclick="saveSettings()" title="Save" /></td>
			<td width="50%"><base:button onclick="window.close()" title="Cancel" /></td>
		</tr>
		</table>
		</form>
	</base:body>
	</base:page>
	<%
}
finally
{
	if (dc != null) dc.close();
}
%>
