<%-- $Id: simple_export.jsp 4476 2008-09-05 15:14:42Z jari $
	------------------------------------------------------------------
	Copyright (C) 2006 Johan Enell, Jari Hakkinen, Nicklas Nordborg
	Copyright (C) 2007 Nicklas Nordborg

	This file is part of BASE - BioArray Software Environment.
	Available at http://base.thep.lu.se/

	BASE is free software; you can redistribute it and/or
	modify it under the terms of the GNU General Public License
	as published by the Free Software Foundation; either version 3
	of the License, or (at your option) any later version.

	BASE is distributed in the hope that it will be useful,
	but WITHOUT ANY WARRANTY; without even the implied warranty of
	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
	GNU General Public License for more details.

	You should have received a copy of the GNU General Public License
	along with this program; if not, write to the Free Software
	Foundation, Inc., 59 Temple Place - Suite 330,
	Boston, MA  02111-1307, USA.
	------------------------------------------------------------------

	@author Nicklas
	@version 2.0
--%>
<%@ page session="false"
	import="net.sf.basedb.core.SessionControl"
	import="net.sf.basedb.core.DbControl"
	import="net.sf.basedb.core.Item"
	import="net.sf.basedb.core.ItemContext"
	import="net.sf.basedb.util.Enumeration"
	import="net.sf.basedb.clients.web.Base"
	import="net.sf.basedb.clients.web.util.HTML"
	import="net.sf.basedb.util.Values"
	import="java.util.Set"
	import="java.util.List"
	
%>
<%@ taglib prefix="base" uri="/WEB-INF/base.tld" %>
<%@ taglib prefix="t" uri="/WEB-INF/tab.tld" %>

<%
final SessionControl sc = Base.getExistingSessionControl(pageContext, true);
final String ID = sc.getId();
final Item itemType = Item.valueOf(request.getParameter("item_type"));
final String subContext = Values.getString(request.getParameter("subcontext"), "");
final ItemContext cc = sc.getCurrentContext(itemType, subContext);
final String defaultColumns = (String)cc.getObject("defaultColumns");
String errorMessage = (String)sc.getSessionSetting("plugin.configure.errors.message");
List<Throwable> errors = (List<Throwable>)sc.getSessionSetting("plugin.configure.errors.list");

%>
	<base:page type="popup" title="Export">
	<base:head styles="parameters.css">
		<script language="JavaScript">
		// Works as long as we don't have more than one list per page
		var tableId = window.opener.document.forms[0].name; 
		
		function init()
		{
			updateColumns();
			if (getSelectedItems().length == 0)
			{
				var frm = document.forms['export'];
				frm['parameter:whichItems'][0].disabled = true;
				var aSelected = document.getElementById('which.selected');
				aSelected.href = 'javascript:void(0)';
				aSelected.disabled = true;
				Main.addClass(aSelected, 'disabled');
			}
		}
		
		// Initialise the visible and hidden column lists
		function initColumns(columns)
		{
			var frm = document.forms['export'];
			var exported = frm.exported;
			var notExported = frm.not_exported;
			exported.length = 0;
			notExported.length = 0;

			var columnDefs = window.opener.Table.getColumnDefs(tableId);
			// Move all columns into the not exported or exported list
			var list = columns == 'all' ? exported : notExported;
			for (var i = 0; i < columnDefs.length; i++) // >
			{
				var col = columnDefs[i];
				if (col.exportable)
				{
					var option = new Option(col.title, col.id);
					list.options[list.options.length] = option;
				}
			}
			if (columns != 'all')
			{
				// Scan columns and move back those that should be exported
				var cols = columns.split(',');
				for (var ic = 0; ic < cols.length; ic++) // >
				{
					var col = columnDefs['id'+cols[ic]];
					if (col)
					{
						for (var ih = 0; ih < notExported.length; ih++) // >
						{
							if (col.id == notExported[ih].value)
							{
								var option = new Option(col.title, col.id);
								exported[exported.length] = option;
								notExported[ih] = null;
								ih = notExported.length;
							}
						}
					}
				}
			}
		}

		// Moves all selected items in list1 to list2
		function moveBetween(list1, list2)
		{
			var moved = 0;
			for(i=0; i < list1.options.length; i++) // >
			{
				if (list1.options[i].selected)
				{
					moved++;
					list2.options[list2.options.length] = new Option(list1.options[i].text, list1.options[i].value, false, true);
					list1.options[i] = null;
					i--;
				}
			}
			if (moved > 0) clearPreset();
		}
		
		// Move all selected items in the list up or down
		function moveSelected(list, up)
		{
			var moved = Forms.moveListOptions(list, up);
			if (moved > 0) clearPreset();
		}
		
		// Sets the preset selection list to the first (empty) element
		function clearPreset()
		{
			var frm = document.forms['export'];
			frm.presets.selectedIndex = 0;
		}
		
		// Update the settings according to the selection in the presets list
		function updateColumns()
		{
			var frm = document.forms['export'];
			var presets = frm.presets;
			var columns = presets.options[presets.selectedIndex].value;
			if (columns == '') return;
			if (columns == '_default_') columns = '<%=defaultColumns%>';
			if (columns == '_current_') columns = window.opener.Table.getColumns(tableId);
			initColumns(columns);
		}
		// Get the "exportProperty" of all exported columns as an array
		function getExportedColumnProperties()
		{
			var list = document.forms['export'].exported;
			var columnDefs = window.opener.Table.getColumnDefs(tableId);
			var selected = new Array();
			for (i = 0; i < list.options.length; i++)	// >
			{
				selected[selected.length] = columnDefs['id'+list.options[i].value].exportProperty;
			}
			return selected;
		}
		// Get the "title" of all exported columns as an array
		function getExportedColumnTitles()
		{
			var list = document.forms['export'].exported;
			var columnDefs = window.opener.Table.getColumnDefs(tableId);
			var selected = new Array();
			for (i = 0; i < list.options.length; i++)	// >
			{
				selected[selected.length] = columnDefs['id'+list.options[i].value].title;
			}
			return selected;
		}
		// Get the ID:s of all selected items
		var selectedItems;
		function getSelectedItems()
		{
			if (!selectedItems)
			{
				selectedItems = window.opener.Table.getSelected(tableId);
			}
			return selectedItems;
		}
		function checkRadio(radio, name)
		{
			Forms.checkRadio(radio, name);
		}
		function doExport()
		{
			var frm = document.forms['export'];
			var exportedProperties = getExportedColumnProperties();
			var exportedTitles = getExportedColumnTitles();
			if (exportedProperties.length == 0)
			{
				alert('You must select at least one column to export');
				return;
			}
			for (var i = 0; i < exportedProperties.length; i++)
			{
				var value = exportedProperties[i] + ':' + exportedTitles[i];
				Forms.createHidden(frm, 'parameter:whichProperties', value);
			}
			if (Forms.getCheckedRadio(frm['parameter:whichItems']).value == 'selected')
			{
				var selectedItems = getSelectedItems();
				for (var i = 0; i < selectedItems.length; i++)
				{
					Forms.createHidden(frm, 'parameter:item', selectedItems[i]);
				}
			}
			if (frm.path.value != '')
			{
				Forms.createHidden(frm, 'parameter:saveAs', frm.path.value);
			}
			frm.submit();
		}
		function browseOnClick()
		{
			Main.openPopup(getRoot()+'filemanager/save_as.jsp?ID=<%=ID%>&callback=setFileCallback', 'SaveAs', 1000, 700);
		}
		function setFileCallback(path)
		{
			var frm = document.forms['export'];
			frm['path'].value = path;
		}
		function hideErrorList()
		{
			Main.hide('errorlist');
			Main.show('showerrorlist');
		}
		function showErrorList()
		{
			Main.show('errorlist');
			Main.hide('showerrorlist');
		}
		function doCancel()
		{
			location = 'index.jsp?ID=<%=ID%>&cmd=CancelWizard';
		}
		</script>
	</base:head>
	<base:body onload="init()">
		<form name="export" action="index.jsp" method="get" onsubmit="return false;">
		<input type="hidden" name="ID" value="<%=ID%>">
		<input type="hidden" name="requestId" value="<%=request.getParameter("requestId")%>">
		<input type="hidden" name="cmd" value="SetParameters">
		<input type="hidden" name="item_type" value="<%=itemType.name()%>">
		<input type="hidden" name="subcontext" value="<%=subContext == null ? "" : subContext%>">
		
		<h3 class="docked">Export options <base:help helpid="simpleexport.options" /></h3>
		<div class="boxed">
		
		<%
		if (errorMessage != null || (errors != null && errors.size() > 0))
		{
			%>
			<div id="errors" style="margin-bottom: 12px;" class="parameterhelp">
				<div class="error" style="margin: 0px;">
				<%=errorMessage %>
				</div>
				<%
				if (errors != null && errors.size() > 0)
				{
					%>
					<div id="showerrorlist" style="display: none;">
						<base:icon image="bullet.gif" /><a href="javascript:showErrorList()">Show details</a>
					</div>
					<div id="errorlist">
					<ol>
					<%
					for (Throwable t : errors)
					{
						%>
						<li><%=t.getMessage()%><br>
						<%
					}
					%>
					</ol>
					<base:icon image="bullet.gif" /><a href="javascript:hideErrorList()">Hide details</a>
					</div>
					<%
				}
				%>
			</div>
			<%
		}
		%>
			<table class="form" width="100%">
			<tr valign="top">
				<td class="prompt">Format</td>
				<td>
					<input type="radio" name="parameter:format" value="text" checked><a 
						href="javascript:checkRadio(document.forms['export']['parameter:format'], 'text');"
						>Tab-separated text file</a><br>
					<input type="radio" name="parameter:format" value="xml"><a 
						href="javascript:checkRadio(document.forms['export']['parameter:format'], 'xml');"
						>XML</a><br>
				</td>
			</tr>
			<tr valign="top">
				<td class="prompt">Which items?</td>
				<td>
					<input type="radio" name="parameter:whichItems" value="selected"><a 
						id="which.selected"
						href="javascript:checkRadio(document.forms['export']['parameter:whichItems'], 'selected');"
						>Selected items</a><br>
					<input type="radio" name="parameter:whichItems" value="page"><a 
						href="javascript:checkRadio(document.forms['export']['parameter:whichItems'], 'page');"
						>Current page</a><br>
					<input type="radio" name="parameter:whichItems" value="all" checked><a 
						href="javascript:checkRadio(document.forms['export']['parameter:whichItems'], 'all');"
						>All pages</a><br>
				</td>
			</tr>
			<tr valign="top">
				<td class="prompt">
					Which columns?<br>
					<select name="presets" onChange="updateColumns()">
						<option>
						<option value="all" title="Export all columns">All
						<option value="_current_" title="Export the currently visible columns" selected>Current
						<%
						if (defaultColumns != null)
						{
							%>
							<option value="_default_" title="Export the default visible columns">Default
							<%
						}
						Enumeration<Integer, String> contexts = sc.getContextNames(itemType, subContext);
						for (int i = 0; i < contexts.size(); ++i)
						{
							ItemContext context = sc.getContext(contexts.getKey(i));
							if (context != null && !ItemContext.DEFAULT_NAME.equals(context.getName()))
							{
								String columns = context.getSetting("columns");
								%>
								<option value="<%=columns%>"><%=HTML.encodeTags(context.getName())%>
								<%
							}
						}
						%>
					</select>
					<br>
					<table align="right">
					<tr>
					<td>
						<base:button
							onclick="moveSelected(document.forms['export'].exported, false)" 
							title="<img src='../../images/move_up.gif' alt='' style='vertical-align: middle;'>" 
							tooltip="Move up" 
						/><p>
						<base:button 
							onclick="moveSelected(document.forms['export'].exported, true)" 
							title="<img src='../../images/move_down.gif' alt='' style='vertical-align: middle;'>" 
							tooltip="Move down" 
						/>
					</td>
					</tr>
					</table>
				</td>
				<td>
					<table border=0 cellspacing=0 cellpadding=2 width="100%">
					<tr>
						<td width="50%">
							<b>Exported columns</b><br>
							<select name="exported" multiple size=10 style="width: 100%;"
								ondblclick="moveBetween(document.forms['export'].exported, document.forms['export'].not_exported)">
							</select>
						</td>
				
						<td>
							<br>
							<base:button
								onclick="moveBetween(document.forms['export'].not_exported, document.forms['export'].exported)" 
								title="<img src='../../images/move_left.gif' alt='' style='vertical-align: middle;'>" 
								tooltip="Make the selected hidden column(s) visible" 
							/><p>
							<base:button 
								onclick="moveBetween(document.forms['export'].exported, document.forms['export'].not_exported)" 
								title="<img src='../../images/move_right.gif' alt='' style='vertical-align: middle;'>" 
								tooltip="Make the selected visible column(s) hidden" 
							/>
							<br>
						</td>
						<td width="50%">
							<b>Not exported</b><br>
							<select name="not_exported" multiple size=10 style="width: 100%;" 
								ondblclick="moveBetween(document.forms['export'].not_exported, document.forms['export'].exported)">
							</select>
						</td>
					</tr>
					</table>
				</td>
			</tr>
			<tr valign="top">
				<td class="prompt">Column prefix</td>
				<td>
					<input type="text" name="parameter:columnPrefix" 
						class="text" size="50" maxlength="255" value=""></td>
			</tr>
			<tr valign="top">
				<td class="prompt">Save as</td>
				<td>
					<table cellpadding="0" border="0" cellspacing="0">
					<tr>
					<td><input type="text" class="text" name="path" size="50" value=""><br>
					Leave empty to download immediately</td>
					<td><base:button 
							title="Browse..."
							onclick="browseOnClick()"
							style="margin-left: 6px;"
							/>
					</td>
					</tr>
					</table>
					<input type="checkbox" name="parameter:overwrite" value="true">
						<a href="javascript:Forms.toggleCheckbox(document.forms['export']['parameter:overwrite'])">Overwrite existing file</a><br>
				</td>
			</tr>
			</table>
		</div>
		</form>
	
		<table align="center">
		<tr>
			<td width="50%"><base:button onclick="doExport();" title="Ok" /></td>
			<td width="50%"><base:button onclick="doCancel();" title="Cancel" /></td>
		</tr>
		</table>
	</base:body>
	</base:page>

